<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\lists\performance;


use app\adminapi\lists\BaseAdminDataLists;
use app\common\model\goods_category\GoodsCategory;
use app\common\model\performance\PerformanceRules;
use app\common\lists\ListsSearchInterface;


/**
 * PerformanceRules列表
 * Class PerformanceRulesLists
 * @package app\adminapi\listsperformance
 */
class PerformanceRulesLists extends BaseAdminDataLists implements ListsSearchInterface
{


    /**
     * @notes 设置搜索条件
     * @return \string[][]
     * @author likeadmin
     * @date 2024/07/15 17:52
     */
    public function setSearch(): array
    {
        return [
            '=' => ['type', 'create_time', 'update_time'],
            '%like%' => ['goods_category_ids'],

        ];
    }


    /**
     * @notes 获取列表
     * @return array
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     * @author likeadmin
     * @date 2024/07/15 17:52
     */
    public function lists(): array
    {
        $data = PerformanceRules::where($this->searchWhere)
            ->field(['id', 'goods_category_ids', 'type', 'rate', 'create_time', 'update_time'])
            ->limit($this->limitOffset, $this->limitLength)
            ->order(['id' => 'desc'])
            ->select()
            ->toArray();
        $goodsCategoryObj = GoodsCategory::where(['status'=>1])->order(['pid' => 'asc','weigh' => 'desc', 'id' => 'desc'])
                        ->select();
        foreach ($data as &$datum) {
            $datum['goods_category_ids_str_arr'] = $goodsCategoryObj->whereIn('id',$datum['goods_category_ids'])->column('name');
        }
        return $data;
    }


    /**
     * @notes 获取数量
     * @return int
     * @author likeadmin
     * @date 2024/07/15 17:52
     */
    public function count(): int
    {
        return PerformanceRules::where($this->searchWhere)->count();
    }

}